
///////////////////////////////////////////////////////////////////////////////////////////////
// LOGIN DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_0() 
{
   oWin = new Form( "Login (user:admin / pass:admin)", 325 , 200 );

   Label( oWin , 65 , 40 , "User:" );
   Label( oWin , 95 , 40 , "Password:" );

   oUser = new TextBox( oWin , 60, 130, "admin" );
   oUser.setFocus();

   oPass = new TextBox( oWin , 90, 130, "admin" , true );

   oOk     = new Button( oWin , 140 , 40 , "Ok" , "test_0_ok( oWin , oUser , oPass )" );  
   oCancel = new Button( oWin , 140 , 170 , "Cancel" , "oWin.release()" );  

}

function test_0_ok( oWin , oUser , oPass )
{

	response = Login ( oUser.getValue() , oPass.getValue() ); 

	if ( response == 'OK' )
	{
		oWin.release();		
	}
	else
	{
		alert('ERROR: Wrong username or password.');
	}

}
 
///////////////////////////////////////////////////////////////////////////////////////////////
// BUTTON DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_1() 
{
   oWin = new Form( "Button Demo", 600 , 300 );

   oBtn1 = new Button( oWin , 50 , 240 , 
	"Set Btn Value" , "oBtn1.setValue('New Value')" );  

   oBtn2 = new Button( oWin , 130 , 240 , 
	"Disable oBtn1" , "oBtn1.disable()" );  

   oBtn3 = new Button( oWin , 170 , 240 , 
	"Enable oBtn1" , "oBtn1.enable()" );  

   oBtn2 = new Button( oWin , 240 , 248 , "Close" , "oWin.release()" );  
}

///////////////////////////////////////////////////////////////////////////////////////////////
// LABEL DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_2() 
{
   oWin = new Form( "Label Demo", 600 , 300 );

   Label( oWin , 100 , 260 , "This is a Label!" );

   Button( oWin , 240 , 248 , "Close" , "oWin.release()" );  
}

///////////////////////////////////////////////////////////////////////////////////////////////
// TEXTBOX DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_3() 
{

	oWin = new Form( "TextBox Demo", 600 , 500 );

	Label( oWin , 50 , 100 , "No Mask" )
	oText = new TextBox( oWin , 50, 320, "Hi!" );

	Label( oWin , 80 , 100 , "setMask ( '(##) ####-####' )" )
	oText2 = new TextBox( oWin , 80, 320, "" );
	oText2.setMask( "(##) ####-####" );

	Label( oWin , 110 , 100 , "setMask ( 'AAAA####' )" )
	oText3 = new TextBox( oWin , 110, 320, "" );
	oText3.setMask( "AAAA####" );

	Label( oWin , 140 , 100 , "setMask ( 'AA.UU.LL.CC-##' )" )
	oText4 = new TextBox( oWin , 140, 320, "" );
	oText4.setMask( "AA.UU.LL.CC-##" );

	Label( oWin , 170 , 100 , "setMask ( '### - ### - ###' )" )
	oText5 = new TextBox( oWin , 170, 320, "" );
	oText5.setMask( "### - ### - ###" );

	Label( oWin , 200 , 100 , "setMask ( 'AAA / AAA / AAA' )" )
	oText6 = new TextBox( oWin , 200, 320, "" );
	oText6.setMask( "AAA - AAA - AAA" );

	Label( oWin , 230 , 100 , "setCurrency ( 6 , 2 , '.' , ',' , '$' )" )
	oText7 = new TextBox( oWin , 230, 320, "" );
	oText7.setCurrency( 6 , 2 , '.' , ',' , '$' );


	Label( oWin , 260 , 10 , "Syntax"  );
	Label( oWin , 290 , 20 , "setCurrency ( nIintDigits, nDecimals, cDecimalSeparator, cGgroupSeparator, cCurrencySymbol )"  );
	Label( oWin , 320 , 20 , "setMask ( cMask )"  );
	Label( oWin , 350 , 20 , "# digit / A alphabetic / U uppercase / L lowercase / C capitalize / ? any character / use \\ to esc."  );

	oText.setFocus();

	Button( oWin , 440 , 110 , "Get TxtBox Value" , "alert( oText.getValue() )" );  
	Button( oWin , 440 , 240 , "Set TxtBox Value" , "oText.setValue('123,456.78')" );  
	Button( oWin , 440 , 370 , "Close" , "oWin.release()" );  

}

///////////////////////////////////////////////////////////////////////////////////////////////
// QUERY DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_4() 
{

	aRecordSet = Query ( 'test' , 
		[ 'code' , 'first' , 'last' , 'birth' , 'married' ] , 
		'code=1 .or. code=2' , '' );

	for ( i = 0 ; i < aRecordSet.length ; i++ )
	{

		code    = aRecordSet [i] [0];
		first   = aRecordSet [i] [1];
		last    = aRecordSet [i] [2];
		birth   = aRecordSet [i] [3];
		married = aRecordSet [i] [4];

		alert( code + ' ' + first + ' ' + last + ' ' + birth + ' ' + married );

	}

}

///////////////////////////////////////////////////////////////////////////////////////////////
// IMAGE DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_5() 
{
   oWin = new Form( "Image Demo", 600 , 300 );

   Image( oWin , 30 , 225 , "img/logo.gif" );

   Button( oWin , 240 , 248 , "Close" , "oWin.release()" );  
}

///////////////////////////////////////////////////////////////////////////////////////////////
// BROWSE DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_6()
{
   oWin = new Form( "Browse Test", 590 , 480 );

   oBrowse = new Browse( oWin , 
	050 , 050 , 510 , 340 , 
	'test' , [ 'code' , 'first' , 'last' , 'birth' , 'married' ] , 
	[ 'Code' , 'First' , 'last' , 'Birth' , 'Married' ] , 
	'.t.' , 
	'code' , 700 );

   Button( oWin , 390 , 40  , "Refresh"         , "oBrowse.refresh()"      );  
   Button( oWin , 390 , 170 , "Show Selected"   , "ShowSelected(oBrowse)"  );  
   Button( oWin , 390 , 300 , "Append"          , "AppendTest( oBrowse )"  );  
   Button( oWin , 390 , 430 , "Edit Selected"   , "Edit( oBrowse )"        );  
                                                                                          
   Button( oWin , 430 , 40  , "Delete Selected" , "DeleteTest(oBrowse)"    );  
   Button( oWin , 430 , 170 , "Select All"      , "SelectAll( oBrowse )"   );  
   Button( oWin , 430 , 300 , "UnSelect All"    , "UnSelectAll( oBrowse )" );  
   Button( oWin , 430 , 430 , "Close"           , "oWin.release()"         );  

}
//---------------------------------------------------------------------------------------------//
function ShowSelected( oBrowse )
{

	if ( oBrowse.getSelectedRowCount() == 0 )
	{
		alert('No Rows Selected!');
		return;
	}

	var aSelection = oBrowse.getSelectedRows();

	for ( var i = 0 ; i < aSelection.length ; i++ )
	{
		nRow = aSelection [i] ;

		code  = oBrowse.getCell( nRow , 1 );
		first = oBrowse.getCell( nRow , 2 );
		last  = oBrowse.getCell( nRow , 3 );

		alert ( code + ' ' + first + last );
	}

}
//---------------------------------------------------------------------------------------------//
function Edit(oBrowse) 
{

	if ( oBrowse.getSelectedRowCount() == 0 )
	{
		alert('No Row Selected!');
		return;
	}

	if ( oBrowse.getSelectedRowCount() > 1 )
	{
		alert('You must select only one row!');
		return;
	}

	var aSelection = oBrowse.getSelectedRows();
	nRow = aSelection [0] ;

	oWin = new Form( "Edit", 325 , 270 );

	Label( oWin , 65  , 40 , "Code:" );
	Label( oWin , 95  , 40 , "First:" );
	Label( oWin , 125 , 40 , "Last:" );

	Label( oWin , 155 , 40 , "Birth:" );
	Label( oWin , 185 , 40 , "Married:" );

	oCode  = new TextBox( oWin , 60  , 130, oBrowse.getCell( nRow , 1 ) );
	oCode.disable();

	oFirst   = new TextBox( oWin , 90  , 130, oBrowse.getCell( nRow , 2 ) );
	oFirst.setFocus();
	oLast    = new TextBox( oWin , 120 , 130, oBrowse.getCell( nRow , 3 ) );
	oBirth   = new DatePicker( oWin , 150, 130, oBrowse.getCell( nRow , 4 ) );
	oMarried = new CheckBox( oWin , 180 , 130 , oBrowse.getCell(nRow,5) );

	oOk     = new Button( oWin , 210 , 40 , "Ok" , "EditOk()" );  
	oCancel = new Button( oWin , 210 , 170 , "Cancel" , "oWin.release()" );  


}

//---------------------------------------------------------------------------------------------//
function EditOk()
{

	Modify( 'test' , [ 'first' , 'last' , 'birth' , 'married' ] , [ oFirst.getValue() , oLast.getValue() , oBirth.getValue() , oMarried.getValue() ] , 'code=' + trim(oCode.getValue()) );

	oBrowse.refresh();

	oBrowse.select(nRow);

	oWin.release();

}

//---------------------------------------------------------------------------------------------//
function AppendTest( oBrowse) 
{

	oWin = new Form( "Append", 325 , 270 );

	Label( oWin , 65  , 40 , "Code:" );
	Label( oWin , 95  , 40 , "First:" );
	Label( oWin , 125 , 40 , "Last:" );

	Label( oWin , 155 , 40 , "Birth:" );
	Label( oWin , 185 , 40 , "Married:" );

	oCode  = new TextBox( oWin , 60  , 130, "" );
	oFirst   = new TextBox( oWin , 90  , 130, "" );
	oLast    = new TextBox( oWin , 120 , 130, "" );
	oBirth   = new DatePicker( oWin , 150, 130, "" );
	oMarried = new CheckBox( oWin , 180 , 130 , "" );

	oOk     = new Button( oWin , 210 , 40 , "Ok" , "AppendOk()" );  
	oCancel = new Button( oWin , 210 , 170 , "Cancel" , "oWin.release()" );  

	oCode.setFocus();

}

//---------------------------------------------------------------------------------------------//
function AppendOk()
{

	// check for duplicates

	aRecordSet = Query ( 'test' , [ 'code' ] , 'code=' + oCode.getValue() , '' );

	if ( aRecordSet.length > 0 )
	{
		alert('Duplicated Code!');
		oCode.setFocus();
		return;
	}

	// if ok, append record.

	Append( 'test' , [ 'code' , 'first' , 'last' , 'birth' , 'married' ] , [ oCode.getValue() , oFirst.getValue() , oLast.getValue() , oBirth.getValue() , oMarried.getValue() ] );

	oBrowse.refresh();

	oWin.release();

}

//---------------------------------------------------------------------------------------------//
function SelectAll( oBrowse )
{
	for ( var i=1 ; i < oBrowse.getRowCount() ; i++ )
	{
		oBrowse.select(i);		
	}
}
//---------------------------------------------------------------------------------------------//
function UnSelectAll(oBrowse)
{
	for ( var i=1 ; i < oBrowse.getRowCount() ; i++ )
	{
		oBrowse.unSelect(i);				
	}
}
//---------------------------------------------------------------------------------------------//
function DeleteTest(oBrowse)
{

	if ( oBrowse.getSelectedRowCount() == 0 )
	{
		alert('No Rows Selected!');
		return;
	}

	var aSelection = oBrowse.getSelectedRows();

	for ( i = 0 ; i < aSelection.length ; i++ )
	{
		xcode  = oBrowse.getCell( aSelection [i] , 1 );
		Delete( 'test' , 'code=' + xcode );
	}

	oBrowse.refresh();

}

///////////////////////////////////////////////////////////////////////////////////////////////
// END BROWSE DEMO
///////////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////////
// COMBOBOX DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_7() 
{
   oWin = new Form( "ComboBox Demo", 620 , 300 );

   oCombo = new ComboBox( oWin , 
	100 , 240 , 
	[ 'one' , 'two' , 'three' ] , 
	[ 'value one' , 'value two' , 'value three' ] , 0 );

   Button( oWin , 240 , 120 , "GetSelectedIndex" , "alert( oCombo.getSelectedIndex() )" );  
   Button( oWin , 240 , 240 , "SetSelectedIndex" , "oCombo.setSelectedIndex(2)" );  

   Button( oWin , 240 , 360 , "Close"            , "oWin.release()" );  

}

///////////////////////////////////////////////////////////////////////////////////////////////
// CHECKBOX DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_8() 
{
   oWin = new Form( "CheckBox Demo", 600 , 300 );

   oCheck = new CheckBox( oWin , 140 , 280 , true );

   Button( oWin , 240 , 080 , "isChecked" , "alert(oCheck.isChecked())" );  
   Button( oWin , 240 , 190 , "check"     , "oCheck.check()" );  
   Button( oWin , 240 , 310 , "unCheck"   , "oCheck.unCheck()" );  
   Button( oWin , 240 , 430 , "Close"     , "oWin.release()" );  

}

///////////////////////////////////////////////////////////////////////////////////////////////
// EDITBOX DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_9() 
{

   oWin = new Form( "EditBox Demo", 600 , 300 );

   oEdit = new EditBox( oWin , 60, 155, "EditBox!" );

   Button( oWin , 240 , 110 , "Get EditBox Value" , "alert( oEdit.getValue() )" );  
   Button( oWin , 240 , 240 , "Set EditBox Value" , "oEdit.setValue('New Value')" );  
   Button( oWin , 240 , 370 , "Close" , "oWin.release()" );  

}

///////////////////////////////////////////////////////////////////////////////////////////////
// GRID DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_10() 
{

   oWin = new Form( "Grid Demo", 510 , 360 );

   oGrid = new Grid( oWin, 40, 020, 480, 190, [ 'One' , 'Two' , 'Three' , 'Four' , 'Five' ], 600 );

   oGrid.addRow ( [ 'cell  1.1' , 'cell  1.2' , 'Cell  1.3' , 'Cell  1.4' , 'Cell  1.5' ] );
   oGrid.addRow ( [ 'cell  2.1' , 'cell  2.2' , 'Cell  2.3' , 'Cell  2.4' , 'Cell  2.5' ] );
   oGrid.addRow ( [ 'cell  3.1' , 'cell  3.2' , 'Cell  3.3' , 'Cell  3.4' , 'Cell  3.5' ] );
   oGrid.addRow ( [ 'cell  4.1' , 'cell  4.2' , 'Cell  4.3' , 'Cell  4.4' , 'Cell  4.5' ] );
   oGrid.addRow ( [ 'cell  5.1' , 'cell  5.2' , 'Cell  5.3' , 'Cell  5.4' , 'Cell  5.5' ] );
   oGrid.addRow ( [ 'cell  6.1' , 'cell  6.2' , 'Cell  6.3' , 'Cell  6.4' , 'Cell  6.5' ] );
   oGrid.addRow ( [ 'cell  7.1' , 'cell  7.2' , 'Cell  7.3' , 'Cell  7.4' , 'Cell  7.5' ] );
   oGrid.addRow ( [ 'cell  8.1' , 'cell  8.2' , 'Cell  8.3' , 'Cell  8.4' , 'Cell  8.5' ] );
   oGrid.addRow ( [ 'cell  9.1' , 'cell  9.2' , 'Cell  9.3' , 'Cell  9.4' , 'Cell  9.5' ] );
   oGrid.addRow ( [ 'cell 10.1' , 'cell 10.2' , 'Cell 10.3' , 'Cell 10.4' , 'Cell 10.5' ] );

   Button( oWin , 240 , 020 , "getRowCount"      , "alert(oGrid.getRowCount())" );  
   Button( oWin , 240 , 140 , "getCell(1,1)"     , "alert(oGrid.getCell(1,1))" );  
   Button( oWin , 240 , 260 , "setCell(1,1)"     , "oGrid.setCell(1,1,'**New**')" );  
   Button( oWin , 240 , 380 , "select(1)"        , "oGrid.select(1)" );  

   Button( oWin , 280 , 020 , "unSelect(1)"      , "oGrid.unSelect(1)" );  
   Button( oWin , 280 , 140 , "deleteRow(1)"     , "oGrid.deleteRow(1)" );  
   Button( oWin , 280 , 260 , "addRow([...])"    , "oGrid.addRow ( [ 'cell x.1' , 'cell x.2' , 'Cell x.3' , 'x.4' , 'x.5' ] )" );  
   Button( oWin , 280 , 380 , "getSele..Rows()"  , "ShowSelectedRows(oGrid)" );  

   Button( oWin , 320 , 210 , "Close"            , "oWin.release()" );  

}

//---------------------------------------------------------------------------------------------//
function ShowSelectedRows(oGrid)
{

	if ( oGrid.getSelectedRowCount() == 0 )
	{
		alert('No Rows Selected!');
		return;
	}

	var aSelection = oGrid.getSelectedRows();

	for ( var i = 0 ; i < aSelection.length ; i++ )
	{
		alert ( aSelection [i] );
	}

}

///////////////////////////////////////////////////////////////////////////////////////////////
// RADIOGROUP DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_11() 
{

   oWin = new Form( "RadioGroup Demo", 600 , 300 );

   oRadio = new RadioGroup( oWin , 90 , 260 , [ 'One' , 'Two' , 'Three' ] , 0 );

   Button( oWin , 240 , 110 , "Get selectedIndex" , "alert(oRadio.getSelectedIndex())" );  
   Button( oWin , 240 , 240 , "Set selectedIndex" , "oRadio.setSelectedIndex(1)" );  
   Button( oWin , 240 , 370 , "Close" , "oWin.release()" );  

}

///////////////////////////////////////////////////////////////////////////////////////////////
// SPINNER DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function test_12() 
{

   alert('This new HTML5 element (input number) is currently(2012.06.30) supported only on Opera, Safari and Chrome');

   oWin = new Form( "Spinner Demo", 600 , 300 );

   oSpinner = new Spinner( oWin , 130, 230, 5 );

   oSpinner.setMin(1);
   oSpinner.setMax(10);
   oSpinner.setStep(0.5);

   Button( oWin , 240 , 110 , "getValue" , "alert( oSpinner.getValue() )" );  
   Button( oWin , 240 , 240 , "setValue" , "oSpinner.setValue(10)" );  

   Button( oWin , 240 , 370 , "Close" , "oWin.release()" );  

}

///////////////////////////////////////////////////////////////////////////////////////////////
// SLIDER DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function Slider_Demo() 
{

   alert('This new HTML5 element (input range) is currently(2012.06.30) supported only on Opera, Safari and Chrome');

   oWin = new Form( "Slider Demo", 600 , 300 );

   oSlider = new Slider( oWin , 130, 230, 5 );

   oSlider.setMin(1);
   oSlider.setMax(10);
   oSlider.setStep(1);

   Button( oWin , 240 , 110 , "getValue" , "alert( oSlider.getValue() )" );  
   Button( oWin , 240 , 240 , "setValue" , "oSlider.setValue(10)" );  

   Button( oWin , 240 , 370 , "Close" , "oWin.release()" );  

}

///////////////////////////////////////////////////////////////////////////////////////////////
// DATEPICKER DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function DatePicker_Demo() 
{

   alert('This new HTML5 element (input date) is currently(2012.06.30) supported only on Opera, Safari and Chrome.');

   oWin = new Form( "DatePicker Demo", 600 , 300 );

   oDatePicker = new DatePicker( oWin , 130, 230, '2012-01-01' );

   Button( oWin , 240 , 110 , "getValue" , "alert( oDatePicker.getValue() )" );  
   Button( oWin , 240 , 240 , "setValue" , "oDatePicker.setValue('2012-12-31')" );  

   Button( oWin , 240 , 370 , "Close" , "oWin.release()" );  

}

///////////////////////////////////////////////////////////////////////////////////////////////
// LISTBOX DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function ListBox_Demo() 
{
   oWin = new Form( "ListBox Demo", 620 , 300 );

   oList = new ListBox( oWin , 
	100 , 240 , 
	[ 'one' , 'two' , 'three' ] , 
	[ 'value one' , 'value two' , 'value three' ] , 5 , 1 );

   Button( oWin , 240 , 120 , "GetSelectedIndex" , "alert( oList.getSelectedIndex() )" );  
   Button( oWin , 240 , 240 , "SetSelectedIndex" , "oList.setSelectedIndex(2)" );  

   Button( oWin , 240 , 360 , "Close"            , "oWin.release()" );  

}
